/********************************************************************************
 *
 *  FILE NAME   :   sample.c
 *  CREATE      :   2007.10.26
 *  MCU         :   M32C/85
 *  VERSION     :   1.00
 *  DESCRIPTION :   
 *
 *==history======================================================================
 *
 ********************************************************************************/

/********************************************************************************
 *      Include Section                                                         *
 ********************************************************************************/
/* M32C/85 SFR */
#include "sfr32c85.h"
/* Open CAN Middle Ware */
#include "can_cmn.h"
#include "can_drv_csw.h"
#include "can_drv_def.h"
#include "can_drv_ext.h"
#include "can_com_def.h"
#include "can_com_ext.h"
#include "can_nm_def.h"
#include "can_nm_ext.h"
#include "can_com_api.h"
/* For CLG3 I/O */
#include "clg3_io.h"

/********************************************************************************
 *      Prot-Type Section                                                       *
 ********************************************************************************/
/* Interrupt */
void BaseTimerInt(void);        /* 1ms             */
void WakeUpCANBusInt(void);     /* CANWakeup       */
void CANErrInterrupt(void);     /* CANError        */
void CANSndInterrupt(void);     /* CANSndComplete  */
void CANRcvInterrupt(void);     /* CANRcvComplete  */
/* Application */
void main(void);                /* Main֐              */
static void Init(void);         /* App֐         */
static UINT8 Wait5ms(void);     /* 5msҋ@֐           */
void InputAPP(void);            /* App͏֐       */
static void TickBASE(void);     /* AppMain֐       */
static void JudgeSleep(void);   /* SleepCheck֐        */
static void OutputStatus(void); /* DIG\֐(For CLG3) */

/* Interrupt Declaration */
#pragma INTERRUPT WakeUpCANBusInt
#pragma INTERRUPT BaseTimerInt
#pragma INTERRUPT CANErrInterrupt
#pragma INTERRUPT CANSndInterrupt
#pragma INTERRUPT CANRcvInterrupt

/********************************************************************************
 *      definition Section                                                      *
 ********************************************************************************/
#define APP_SOURCE_ID_MASK   (~CAN_NM_WINDOW_MASK) & (UINT16)(0x7ff)    /* Source ID Mask */
#define APP_SOURCE_ID        (UINT8)(CAN_NM_MY_CAN_ID & APP_SOURCE_ID_MASK) /* Source ID */

/********************************************************************************
 *      Variable Section                                                        *
 ********************************************************************************/
/* C^C} */
static UINT8 main_time = 0;
/* Mf[^ */
static UINT8 smsg[] = { 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f};

/********************************************************************************
 *
 *  Function    :   void main(void)
 *  INPUT       :   None
 *  OUTPUT      :   None
 *  DESCRIPTION :   Main֐
 *
 *==history======================================================================
 *
 ********************************************************************************/
void main(void)
{
    /*  */
    FncSetCANIntLVLDRV();  /* can荞݃x */
    Init();             /* AvP[V */
    InitCOM();          /* COM */
    InitNM();           /* NM */
    
    /* MgpXbg̋ */
    SetSndUseReqCOM(0x110,CAN_COM_SND_ON);
    SetSndUseReqCOM(0x120,CAN_COM_SND_ON);
    SetSndUseReqCOM(0x130,CAN_COM_SND_ON);
    SetSndUseReqCOM(0x140,CAN_COM_SND_ON);
    
    /* C[v */
    while (1)
    {
        while (Wait5ms() == FALSE)
        {
            ;
        }   /* 5msec҂ */
        /* APP͏ */
        InputAPP();
        
        /* COMM */
        RcvCOM();
        
        TickBASE();
        
        /* NM */
        TickNM();
        
        if (clg3GetPush(CLG3_PUSH_K10,CLG3_SW_TRG)) /* SW6 Push */
        {
            /* bZ[WM */
            SendMessage((0x0700 | APP_SOURCE_ID), 8, smsg);
        }
        
        /* COMM */
        SndCOM();
        
    }
}


/********************************************************************************
 *
 *  Function    :   void Init(void)
 *  INPUT       :   None
 *  OUTPUT      :   None
 *  DESCRIPTION :   ECU
 *
 *==history======================================================================
 *
 ********************************************************************************/
void Init(void)
{
    /* PLLNbNݒ 32MHz */
    prc0 = 1;       /* CM0,CM1,CM2,MCD,PLC0,PLC1̏݋ */
    cm05 = 0;       /* NbNU */
    asm("nop");     /* NbNU҂ */
    asm("nop");
    asm("nop");
    mcd = 0x12;     /* CNbN , Ȃ */
    cm07 = 0;       /* CM21Kp */
    cm21 = 0;       /* CM17Kp */
    cm04 = 0;       /* o̓|[g@\ */
    plc = 0x0254;   /* 8{A2 */
    plc = 0x02d4;   /* PLLU */
    asm("nop");     /* PLLU҂ */
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    cm1 = 0xa0;     /* PLLNbNUJn */
    prcr = 0x00;    /* CM0,CM1,CM2,MCD,PLC0,PLC1̏݋֎~ */
    
    /* CLG3pIO */
    clg3InitIo();
    
    /* Cp^C}ݒ */
    tb2mr = 0x00;                           /* f1 & Timer mode              */
    tb2 = (UINT16)(1600-1);                 /* 50usec                       */
    tb2ic = 0;                              /* set interrupt level(disable) */
    tb2s = 1;                               /* TimerB2 start                */
    onsf = 0x40;
    ta0mr = 0x01;                           /* Event Counter mode  */
    ta0ic = 3;                              /* set interrupt level */
    ta0 = (UINT8)(20-1);                    /* 50usec * 20 = 1msec */
    ta0s = 1;                               /* TimerA0 start       */
    
    asm("FSET I");  /* 荞݋ */
}


/********************************************************************************
 *
 *  Function    :   UINT8 Wait5ms(void)
 *  INPUT       :   None
 *  OUTPUT      :   UINT8   TRUE    :   Co
 *                          FALSE   :   Co
 *  DESCRIPTION :   C5msecv
 *
 *==history======================================================================
 *
 ********************************************************************************/
UINT8 Wait5ms(void)
{
    UINT8 result = FALSE;

    asm("FCLR I");  /* 荞݋֎~ */
    if (main_time >= 5)
    {
        main_time = 0;
        result = TRUE;
    }
    asm("FSET I");  /* 荞݋ */

    return result;
}


/********************************************************************************
 *
 *  Function    :   void InputAPP(void)
 *  INPUT       :   None
 *  OUTPUT      :   None
 *  DESCRIPTION :   APP͏
 *
 *==history======================================================================
 *
 ********************************************************************************/
void InputAPP(void)
{
    clg3InputIo();  /* CLG3XCb`͎擾 */
}


/********************************************************************************
 *
 *  Function    :   void TickBASE(void)
 *  INPUT       :   None
 *  OUTPUT      :   None
 *  DESCRIPTION :   AppC
 *
 *==history======================================================================
 *
 ********************************************************************************/
void TickBASE(void)
{
    /* CAN-ID 220 */
    api_snddata[1].byte[0] = api_rcvdata[0].byte[0];
    /* CAN-ID 230 */
    api_snddata[2].byte[0] = api_rcvdata[1].byte[0];
    /* CAN-ID 240 */
    api_snddata[3].byte[0] = api_rcvdata[2].byte[0];

    JudgeSleep();   /* SleepAWakeUp */
    
    OutputStatus(); /* Xe[^X\ */
}


/********************************************************************************
 *
 *  Function    :   void JudgeSleep(void)
 *  INPUT       :   None
 *  OUTPUT      :   None
 *  DESCRIPTION :   SleepAWakeUp
 *
 *==history======================================================================
 *
 ********************************************************************************/
void JudgeSleep(void)
{
    if (clg3GetDip(CLG3_DIP_SW1))
    {
        GoToMode(CAN_NM_AWAKE);  /* WakeUp */
    }
    else
    {
        GoToMode(CAN_NM_BUS_SLEEP);  /* Sleep */
    }
}


/********************************************************************************
 *
 *  Function    :   void OutputStatus(void)
 *  INPUT       :   None
 *  OUTPUT      :   None
 *  DESCRIPTION :   Xe[^X\
 *
 *==history======================================================================
 *
 ********************************************************************************/
void OutputStatus(void)
{
    NetStsType nm_sts;

    GetStatus(&nm_sts); /* lbg[NXe[^X擾 */

    /* lbg[NXe[^X\ */
    clg3SetDig(2,(nm_sts.byte & 0x0F),1);
    clg3SetDig(3,((nm_sts.byte & 0xF0)>>4),1);

    /* LED\ */
    clg3DispDig();
}


/********************************************************************************
 *
 *  Function    :   void CANRcvInterrupt(void)
 *  INPUT       :   None
 *  OUTPUT      :   None
 *  DESCRIPTION :   CANM荞
 *
 *==history======================================================================
 *
 ********************************************************************************/
void CANRcvInterrupt(void)
{
    FncCANRcvIntDRV();
}


/********************************************************************************
 *
 *  Function    :   void CANSndInterrupt(void)
 *  INPUT       :   None
 *  OUTPUT      :   None
 *  DESCRIPTION :   CANM荞
 *
 *==history======================================================================
 *
 ********************************************************************************/
void CANSndInterrupt(void)
{
    FncCANSndIntDRV();
}


/********************************************************************************
 *
 *  Function    :   void CANErrInterrupt(void)
 *  INPUT       :   None
 *  OUTPUT      :   None
 *  DESCRIPTION :   CANG[荞
 *
 *==history======================================================================
 *
 ********************************************************************************/
void CANErrInterrupt(void)
{
    FncCANErrIntDRV();
}


/********************************************************************************
 *
 *  Function    :   void WakeUpCANBusInt(void)
 *  INPUT       :   None
 *  OUTPUT      :   None
 *  DESCRIPTION :   CANWakeUp荞
 *
 *==history======================================================================
 *
 ********************************************************************************/
void WakeUpCANBusInt(void)
{
    FncAfterSlpNM();
}


/********************************************************************************
 *
 *  Function    :   void BaseTimerInt(void)
 *  INPUT       :   None
 *  OUTPUT      :   None
 *  DESCRIPTION :   Cp^C}荞
 *
 *==history======================================================================
 *
 ********************************************************************************/
void BaseTimerInt(void)
{
    CntCOM();       /* COM1msJEg */
    main_time++;    /* C10mspJE^CNg */
}
