/*
 *	TOPPERS NonOS CAN Middleware
 *		Toyohashi Open Platform for Embedded Real-Time Systems
 *		NonOS CAN Middleware
 * 
 *	Copyright (C) 2007 Sunny Giken Inc.
 * 
 *	L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *	ɂČ\Ă GNU General Public License  Version 2 ɋL
 *	qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *	ς̂܂ށDȉjgpEEρEĔzziȉC
 *	pƌĂԁj邱Ƃ𖳏ŋD
 *	(1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *		\C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *		XR[hɊ܂܂Ă邱ƁD
 *	(2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *		pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *		҃}jAȂǁjɁCL̒쌠\C̗pщL
 *		̖ۏ؋Kfڂ邱ƁD
 *	(3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *		płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *		ƁD
 *	  (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *		  쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *	  (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *		  񍐂邱ƁD
 *	(4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *		QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *	{\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *	TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *	܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *	ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */
/*
 *@Version 1.00  2007.10.26
 */

/*
 *	CMW-AALW[
 */

/*---------------------------------------------------------------------------*/
/*  wb_t@C̃CN[h                                             */
/*---------------------------------------------------------------------------*/
#include "can_cmn.h"                        /* COM/NM/DRIVERgׂ̑S */
#include "can_com_def.h"                    /* COMpUSER`t@C       */
#include "can_com_ext.h"                    /* COMO[o`t@C     */
#ifdef CAN_COM_NM_INDIRECT
#include "can_nm_csw.h"                     /* NMRpCSW`t@C    */
#endif
#include "can_nm_def.h"                     /* NMpUSER`t@C        */
#include "can_nm_ext.h"                     /* NMO[o`t@C      */


/*---------------------------------------------------------------------------*/
/*  ֐prototype錾                                                      */
/*---------------------------------------------------------------------------*/


/*********************************************************************/
/*  Function name : StatusType GetCOMCtrlSts(COMStsType *sts)        */
/*-------------------------------------------------------------------*/
/*  Description : COM̑M󋵂i[                          */
/*                s^C~O: C                               */
/*-------------------------------------------------------------------*/
/*  parameter : COMStsType *sts                                      */
/*  result    : StatusType CAN_E_OK:i[                         */
/*                         CAN_E_NG:i[ُ                         */
/*********************************************************************/
StatusType GetCOMCtrlSts(COMStsType *sts)
{
    /* ϐ */
    StatusType m_result;
    NMCOMStsType m_nm_com;
    /* vO */
    m_result = GetCOMCtrlStsNM(&m_nm_com);
    if(m_result == CAN_E_OK)
    {
        m_nm_com.byte = (UINT8)(m_nm_com.byte & CAN_COM_MODE_MASK);
        switch(m_nm_com.byte){
            case CAN_NM_STP:
                sts->byte = CAN_COM_STP;
                break;
            case CAN_NM_RCVONLY:
                sts->byte = CAN_COM_RCVONLY;
                break;
            case CAN_NM_WAITING:
                sts->byte = CAN_COM_WAITING;
                break;
            case CAN_NM_NML:
                sts->byte = CAN_COM_NML;
                break;
            default:
                sts->byte = CAN_COM_STP;
                m_result = CAN_E_NG;
                break;
        }
    }
    return m_result;
}

/*********************************************************************/
/*  Function name : StatusType GetNMStatus(UINT8 *sts)               */
/*-------------------------------------------------------------------*/
/*  Description : ݂NMXe[^XCOM֏ԂԂ              */
/*                s^C~O: C                               */
/*-------------------------------------------------------------------*/
/*  parameter : UINT8      *sts                                      */
/*  result    : StatusType CAN_E_OK:i[                         */
/*                         CAN_E_NG:i[ُ                         */
/*********************************************************************/
StatusType GetNMStatus(UINT8 *sts)
{
    StatusType m_result;
    NetStsType m_nm_mode;
    
    m_result = GetStatus(&m_nm_mode);
    
    if(m_result == CAN_E_OK)
    {
        if(m_nm_mode.bit.StatusLimpHome == CAN_ON)
        {
            *sts = CAN_COM_BUSOFF;
        }
        else if(m_nm_mode.bit.StatusWaitBusSleep == CAN_ON)
        {
            *sts = CAN_COM_TWBSNORMAL;
        }
        else
        {
            *sts = CAN_COM_BUSOTHER;
        }

    }
    
    return m_result;
}