/*
 *	TOPPERS NonOS CAN Middleware
 *		Toyohashi Open Platform for Embedded Real-Time Systems
 *		NonOS CAN Middleware
 * 
 *	Copyright (C) 2007 Sunny Giken Inc.
 * 
 *	L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *	ɂČ\Ă GNU General Public License  Version 2 ɋL
 *	qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *	ς̂܂ށDȉjgpEEρEĔzziȉC
 *	pƌĂԁj邱Ƃ𖳏ŋD
 *	(1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *		\C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *		XR[hɊ܂܂Ă邱ƁD
 *	(2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *		pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *		҃}jAȂǁjɁCL̒쌠\C̗pщL
 *		̖ۏ؋Kfڂ邱ƁD
 *	(3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *		płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *		ƁD
 *	  (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *		  쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *	  (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *		  񍐂邱ƁD
 *	(4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *		QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *	{\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *	TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *	܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *	ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */
/*
 *@Version 1.00  2007.10.26
 */

#ifndef __CAN_DRV_H_INCLUDE__
#define __CAN_DRV_H_INCLUDE__
/*--------------------------------------------------------------------------*/
/* ^`                                                                   */
/*--------------------------------------------------------------------------*/
/* 荞݂̐ݒ */
#define CAN_WKUP_P77_TA3MR    ((UINT8)(0x01))   /* CxgJE^[[h */
#define CAN_WKUP_P77_TA3      ((UINT16)(0x01))  /* TA3JEg              */
#define CAN_WKUP_P77_TRGSR    ((UINT8)(0xCF))   /* TA3gK => TA3inI   */

/* 16Tqpݒl */
#if CAN_NUM_TQ == CAN_DRV_16TQ
    #if CAN_CLK == CAN_DRV_CLK_32MHZ
        #if CAN_BAUDRATE == CAN_DRV_250KBPS
            /* (PTS,PBS1,PBS2,SJW,SAM) = (6,5,4,4,1) */
            /* 1bit = 16TQ(=1+6+5+4) */
            #define CAN_BRP      ((UINT8)(0x07))
            #define CAN_CONR_MAT  ((UINT16)(0x0DCA0))
        /* 500Kbpspݒl */
        #elif CAN_BAUDRATE == CAN_DRV_500KBPS
            /* (PTS,PBS1,PBS2,SJW,SAM) = (7,5,3,2,1) */
            /* 1bit = 16TQ(=1+7+5+3) */
            #define CAN_BRP      ((UINT8)(0x03))
            #define CAN_CONR_MAT  ((UINT16)(0x054C0))
        #else
            /* 500kbps/250kbpsȊOI(Ȃ) */
        #endif
    #else
        /* 32MHzȊOI(Ȃ) */
    #endif

/* 20Tqpݒl */
#elif CAN_NUM_TQ == CAN_DRV_20TQ
    #if CAN_CLK == CAN_DRV_CLK_20MHZ
        #if CAN_BAUDRATE == CAN_DRV_250KBPS
            /* (PTS,PBS1,PBS2,SJW,SAM) = (7,7,5,4,1) */
            /* 1bit = 20TQ(=1+7+7+5) */
            #define CAN_BRP      ((UINT8)(0x03))
            #define CAN_CONR_MAT  ((UINT16)(0x0E6C0))
        /* 500Kbpspݒl */
        #elif CAN_BAUDRATE == CAN_DRV_500KBPS
            /* (PTS,PBS1,PBS2,SJW,SAM) = (8,7,4,3,1) */
            /* 1bit = 20TQ(=1+8+7+4) */
            #define CAN_BRP      ((UINT8)(0x01))
            #define CAN_CONR_MAT  ((UINT16)(0x09EE0))
        #else
            /* 500kbps/250kbpsȊOI(Ȃ) */
        #endif
    #elif CAN_CLK == CAN_DRV_CLK_30MHZ
        #if CAN_BAUDRATE == CAN_DRV_250KBPS
            /* (PTS,PBS1,PBS2,SJW,SAM) = (7,7,5,4,1) */
            /* 1bit = 20TQ(=1+7+7+5) */
            #define CAN_BRP      ((UINT8)(0x05))
            #define CAN_CONR_MAT  ((UINT16)(0x0E6C0))
        /* 500Kbpspݒl */
        #elif CAN_BAUDRATE == CAN_DRV_500KBPS
            /* (PTS,PBS1,PBS2,SJW,SAM) = (8,7,4,3,1) */
            /* 1bit = 20TQ(=1+8+7+4) */
            #define CAN_BRP      ((UINT8)(0x02))
            #define CAN_CONR_MAT  ((UINT16)(0x09EE0))
        #else
            /* 500kbps/250kbpsȊOI(Ȃ) */
        #endif
    #else
        /* 20MHz,30MHzȊOI(Ȃ) */
    #endif
#else
   /* 16TQ,20TQȊOI(Ȃ) */
#endif


/* DRV݂̂Ŏgp` */
#define CAN_DRV_RESET            ((UINT16)(0x0011)) /* Zbg[hݒl      */
#define CAN_DRV_RUN              ((UINT16)(0x0F0A)) /* RUN[hݒl           */
#define CAN_DRV_SET_RCV          ((UINT8)(0x40))    /* Mpݒl              */
#define CAN_DRV_SET_TRM          ((UINT8)(0x80))    /* Mpݒl              */
#define CAN_DRV_SLOT14           ((UINT8)(14))      /* NMMpSLOT14            */
#define CAN_DRV_SLOT15           ((UINT8)(15))      /* NMMpSLOT15            */
#define CAN_DRV_SIDL_MASK        ((UINT16)(0x003F)) /* SIDL̃}XNl            */
#define CAN_DRV_SIDH_MASK        ((UINT16)(0x001F)) /* SIDH̃}XNl            */
#define CAN_DRV_SIDH_SIFT        ((UINT8)(6))       /* SIDH̃Vtgl            */
#define CAN_DRV_MDR_MASK         ((UINT8)(0x03))    /* [hWX^}XNl    */
#define CAN_DRV_COMSLOT          ((UINT8)(12))      /* COMMpXbg         */
#define CAN_DRV_NMSLOT           ((UINT8)(11))      /* NMMpXbg          */
#define CAN_DRV_NMSND_SLOT_NUM   ((UINT8)(11))      /* NM̑MXbg          */
#define CAN_DRV_COMSND_SLOT_NUM  ((UINT8)(12))      /* COM̑MXbg         */
#define CAN_DRV_RESERV_SLOT_NUM  ((UINT8)(13))      /* reserṽXbg          */
#define CAN_DRV_DLC_MAX          ((UINT8)(8))       /* DLCMAXl                */
#define CAN_SID_MAX              ((UINT16)(0x07ff)) /* CAN-IDMAXl             */
#define CAN_DRV_EIMKRMASK        ((UINT8)(0x07))    /* G[荞݃}XN      */
                                                    /* WX^̃}XNl        */
#define CAN_DRV_INTMASK          ((UINT16)(0x8000)) /* SIMKRݒp               */
#define CAN_DRV_ERRINT           ((UINT8)(0x01))    /* EIMKRݒp               */
#define CAN_DRV_SET_MOD          ((UINT16)(0x0019)) /* LoopBackӰމ          */
                                                    /* BASICCANӰސݒ          */
                                                    /* MsgOrderݒ(Byte)    */
                                                    /* BusERR荞݉        */
                                                    /* TimStmpSreScale       */
#define CAN_DRV_SET_MOD_MASK     ((UINT16)(0x0F1B)) /* CANڼ޽Ͻl         */

/* 500Kbps:2sȏA250Kbps:4sȏi1rbgj */
#define WaitChgMsg       (12)           /* CAN Run -> CAN Reset܂łwait    */

#if CAN_BAUDRATE == CAN_DRV_500KBPS     /* 500KBPSݒ̏ꍇwait           */
    #if CAN_CLK == CAN_DRV_CLK_32MHZ    /* CPUNbNg̑I               */
        /* 6sȏi3rbgj */
        #define WaitChgMod       (19)   /* CAN Reset -> CAN Run܂łwait    */
        /* 260sȏi1t[^Cj */
        #define WaitFrameEnd     (640)  /* A{[gpwait                        */

    #elif CAN_CLK == CAN_DRV_CLK_30MHZ  /* CPUNbNg̑I               */
        /* 6sȏi3rbgj */
        #define WaitChgMod       (18)   /* CAN Reset -> CAN Run܂łwait    */
        /* 260sȏi1t[^Cj */
        #define WaitFrameEnd     (600)  /* A{[gpwait                        */

    #elif CAN_CLK == CAN_DRV_CLK_20MHZ  /* CPUNbNg̑I               */
        /* 6sȏi3rbgj */
        #define WaitChgMod       (12)   /* CAN Reset -> CAN Run܂łwait    */
        /* 260sȏi1t[^Cj */
        #define WaitFrameEnd     (400)  /* A{[gpwait                        */
    #else
        /* LȊOCPUNbNI(Ȃ) */
    #endif

#elif CAN_BAUDRATE == CAN_DRV_250KBPS   /* 250KBPSݒ̏ꍇwait           */
    #if CAN_CLK == CAN_DRV_CLK_32MHZ    /* CPUNbNg̑I               */
        /* 12sȏi3rbgj */
        #define WaitChgMod       (38)   /* CAN Reset -> CAN Run܂łwait    */
        /* 520sȏi1t[^Cj */
        #define WaitFrameEnd     (1280) /* A{[gpwait                        */

    #elif CAN_CLK == CAN_DRV_CLK_30MHZ  /* CPUNbNg̑I               */
        /* 12sȏi3rbgj */
        #define WaitChgMod       (36)   /* CAN Reset -> CAN Run܂łwait    */
        /* 520sȏi1t[^Cj */
        #define WaitFrameEnd     (1200) /* A{[gpwait                        */

    #elif CAN_CLK == CAN_DRV_CLK_20MHZ  /* CPUNbNg̑I               */
        /* 12sȏi3rbgj */
        #define WaitChgMod       (24)   /* CAN Reset -> CAN Run܂łwait    */
        /* 520sȏi1t[^Cj */
        #define WaitFrameEnd     (800)  /* A{[gpwait                        */
    #else
        /* LȊOCPUNbNI(Ȃ) */
    #endif

#else
    /* LȊÕ{[[gI(Ȃ) */
#endif

/* fcan250ł500ł֌W */
/* 17fcan */
#define WaitCANClk       (3)                /* SRAM]҂pwait            */

#define CAN_DRV_RCVSLOT_MAX ((UINT8)(11))   /* COMMSLOTő吔             */


/*--------------------------------------------------------------------------*/
/*  ^`                                                                  */
/*--------------------------------------------------------------------------*/
struct can_bit_def_8{
    UINT8     b0:1;
    UINT8     b1:1;
    UINT8     b2:1;
    UINT8     b3:1;
    UINT8     b4:1;
    UINT8     b5:1;
    UINT8     b6:1;
    UINT8     b7:1;
};
union CAN_ByteType{
    struct  can_bit_def_8   bit;
    UINT8     byte;
};

struct can_bit_def_16{
    UINT16    b0:1;
    UINT16    b1:1;
    UINT16    b2:1;
    UINT16    b3:1;
    UINT16    b4:1;
    UINT16    b5:1;
    UINT16    b6:1;
    UINT16    b7:1;
    UINT16    b8:1;
    UINT16    b9:1;
    UINT16    b10:1;
    UINT16    b11:1;
    UINT16    b12:1;
    UINT16    b13:1;
    UINT16    b14:1;
    UINT16    b15:1;
};
union CAN_WordType{
    struct  can_bit_def_16  bit;
    UINT16    word;
};

union CAN_DRV_Status {
    struct{
        UINT8 SndCompNM:1;      /* NMM  */
        UINT8 SndCompCOM:1;     /* COMM */
        UINT8 BusOff:1;         /* oXIt    */
        UINT8 InvalNM:1;        /* NMM    */
        UINT8 InvalCOM:1;       /* COMM   */
        UINT8 dummy:3;
    }bit;
    UINT8 byte;
};

#endif  /* __CAN_DRV_H_INCLUDE__ */

/****** End of File *********************************************************/
