/*
 *	TOPPERS NonOS CAN Middleware
 *		Toyohashi Open Platform for Embedded Real-Time Systems
 *		NonOS CAN Middleware
 * 
 *	Copyright (C) 2007 Sunny Giken Inc.
 * 
 *	L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *	ɂČ\Ă GNU General Public License  Version 2 ɋL
 *	qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *	ς̂܂ށDȉjgpEEρEĔzziȉC
 *	pƌĂԁj邱Ƃ𖳏ŋD
 *	(1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *		\C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *		XR[hɊ܂܂Ă邱ƁD
 *	(2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *		pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *		҃}jAȂǁjɁCL̒쌠\C̗pщL
 *		̖ۏ؋Kfڂ邱ƁD
 *	(3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *		płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *		ƁD
 *	  (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *		  쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *	  (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *		  񍐂邱ƁD
 *	(4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *		QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *	{\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *	TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *	܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *	ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */
/*
 *@Version 1.00  2007.10.26
 */

#ifndef __CAN_DRV_SFR_H_INCLUDE__
#define __CAN_DRV_SFR_H_INCLUDE__

/*---------------------------------------------------------------------------*/
/*  8bit rbgtB[h`                                                */
/*---------------------------------------------------------------------------*/
typedef struct {
   UINT8  b0      :1;
   UINT8  b1      :1;
   UINT8  b2      :1;
   UINT8  b3      :1;
   UINT8  b4      :1;
   UINT8  b5      :1;
   UINT8  b6      :1;
   UINT8  b7      :1;
}CAN_BITDEF8;

union CAN_BYTEDEF{
   CAN_BITDEF8  bit;
   UINT8          byte;
};

/*---------------------------------------------------------------------------*/
/*  16bit rbgtB[h`                                               */
/*---------------------------------------------------------------------------*/
typedef struct _can_bit_def_16 {
    UINT8  b0      :1;
    UINT8  b1      :1;
    UINT8  b2      :1;
    UINT8  b3      :1;
    UINT8  b4      :1;
    UINT8  b5      :1;
    UINT8  b6      :1;
    UINT8  b7      :1;
    UINT8  b8      :1;
    UINT8  b9      :1;
    UINT8  b10     :1;
    UINT8  b11     :1;
    UINT8  b12     :1;
    UINT8  b13     :1;
    UINT8  b14     :1;
    UINT8  b15     :1;
}CAN_BITDEF16;

union CAN_WORDDEF{
   CAN_BITDEF16  bit;
   UINT16         word;
};

typedef struct _can_byte_hl {
    UINT8  low;
    UINT8  high;
}CAN_BYTE_HL;

/*---------------------------------------------------------------------------*/
/*  CANXbgΉ rbgtB[h`                                     */
/*---------------------------------------------------------------------------*/
typedef struct _can_slot_bit_def {
    UINT8  slot0   :1;
    UINT8  slot1   :1;
    UINT8  slot2   :1;
    UINT8  slot3   :1;
    UINT8  slot4   :1;
    UINT8  slot5   :1;
    UINT8  slot6   :1;
    UINT8  slot7   :1;
    UINT8  slot8   :1;
    UINT8  slot9   :1;
    UINT8  slot10  :1;
    UINT8  slot11  :1;
    UINT8  slot12  :1;
    UINT8  slot13  :1;
    UINT8  slot14  :1;
    UINT8  slot15  :1;
}CAN_SLOTBITDEF;

typedef union _can_slot_def {
    CAN_SLOTBITDEF  bit;
    CAN_BYTE_HL     byte;
    UINT16      word;
}CAN_SLOTDEF;
/*---------------------------------------------------------------------------*/
/*  XyVWX^ AhXt                                      */
/*---------------------------------------------------------------------------*/
/* M32C/85IꂽƂ(CAN2CHȏ) */
#if CAN_CH == CAN_DRV_CH0
    #pragma ADDRESS can_ctlr0      0200h       /* 䃌WX^                  */
    #pragma ADDRESS can_str        0202h       /* CAN0Xe[^XWX^        */
    #pragma ADDRESS can_idr        0204h       /* CAN0gIDWX^            */
    #pragma ADDRESS can_conr       0206h       /* CAN0oX^C~O䃌WX^*/
    #pragma ADDRESS can_tsr        0208h       /* CAN0^CX^vWX^    */
    #pragma ADDRESS can_tecr       020ah       /* CAN0MG[JEgWX^*/
    #pragma ADDRESS can_recr       020bh       /* CAN0MG[JEgWX^*/
    #pragma ADDRESS can_sistr      020ch       /* CAN0Xbg荞          */
                                               /*            Xe[^XWX^ */

    #pragma ADDRESS can_simkr      0210h       /* CAN0Xbg荞          */
                                               /*                }XNWX^ */
    #pragma ADDRESS can_eimkr      0214h       /* CAN0G[荞            */
                                               /*                }XNWX^ */
    #pragma ADDRESS can_eistr      0215h       /* CAN0G[荞            */
                                               /*            Xe[^XWX^ */
    #pragma ADDRESS can_efr        0216h       /* CAN0G[vWX^        */
    #pragma ADDRESS can_brp        0217h       /* CAN0{[[gvXP[    */
    #pragma ADDRESS can_mdr        0219h       /* CAN0[hWX^            */

    #pragma ADDRESS can_ssctlr     0220h       /* CAN0VOVbg          */
                                               /*          Rg[WX^ */
    #pragma ADDRESS can_ssstr      0224h       /* CAN0VOVbg          */
                                               /*            Xe[^XWX^ */


    /* -- }XNWX^ -- */
    #pragma ADDRESS can_gmr        0228h       /* O[o}XNWX^      */
    #pragma ADDRESS can_lmar       0230h       /* [J}XNWX^A       */
    #pragma ADDRESS can_lmbr       0238h       /* [J}XNWX^B       */

    /* -- CANbZ[W䃌WX^ -- */
    #pragma ADDRESS can_mctl       0230h       /* CAN0bZ[W䃌WX^S*/
    #pragma ADDRESS can_mctl0      0230h       /* CAN0bZ[W䃌WX^0   */
    #pragma ADDRESS can_mctl1      0231h       /* CAN0bZ[W䃌WX^1   */
    #pragma ADDRESS can_mctl2      0232h       /* CAN0bZ[W䃌WX^2   */
    #pragma ADDRESS can_mctl3      0233h       /* CAN0bZ[W䃌WX^3   */
    #pragma ADDRESS can_mctl4      0234h       /* CAN0bZ[W䃌WX^4   */
    #pragma ADDRESS can_mctl5      0235h       /* CAN0bZ[W䃌WX^5   */
    #pragma ADDRESS can_mctl6      0236h       /* CAN0bZ[W䃌WX^6   */
    #pragma ADDRESS can_mctl7      0237h       /* CAN0bZ[W䃌WX^7   */
    #pragma ADDRESS can_mctl8      0238h       /* CAN0bZ[W䃌WX^8   */
    #pragma ADDRESS can_mctl9      0239h       /* CAN0bZ[W䃌WX^9   */
    #pragma ADDRESS can_mctl10     023ah       /* CAN0bZ[W䃌WX^10  */
    #pragma ADDRESS can_mctl11     023bh       /* CAN0bZ[W䃌WX^11  */
    #pragma ADDRESS can_mctl12     023ch       /* CAN0bZ[W䃌WX^12  */
    #pragma ADDRESS can_mctl13     023dh       /* CAN0bZ[W䃌WX^13  */
    #pragma ADDRESS can_mctl14     023eh       /* CAN0bZ[W䃌WX^14  */
    #pragma ADDRESS can_mctl15     023fh       /* CAN0bZ[W䃌WX^15  */

    /* -- Xbgobt@IWX^ -- */
    #pragma ADDRESS can_sbs        0240h       /* Xbgobt@IWX^  */

    /* -- CAN0䃌WX^1 -- */
    #pragma ADDRESS can_ctlr1      0241h       /* CAN0䃌WX^              */

    /* -- CAN0X[v䃌WX^ -- */
    #pragma ADDRESS can_slpr       0242h       /* CAN0X[v䃌WX^      */

    /* -- CAN0ANZv^XtB^T|[gWX^ -- */
    #pragma ADDRESS can_afs        0244h       /* CAN0ANZv^XtB^    */
                                               /*              T|[gWX^ */
    /* -- bZ[WXbgf[^ -- */
    #pragma ADDRESS can_slot_buf   01e0h       /* CAN0ү޽ۯޯ̧           */
    #pragma ADDRESS can_slot_buf0  01e0h       /* CAN0ү޽ۯޯ̧0          */
    #pragma ADDRESS can_slot_buf1  01f0h       /* CAN0ү޽ۯޯ̧1          */

    /* -- 荞ݐ䃌WX^ -- */
    #pragma ADDRESS can0ic         009dh       /* CAN0荞ݐ䃌WX^0     */
    #pragma ADDRESS can1ic         007fh       /* CAN0荞ݐ䃌WX^1     */
    #pragma ADDRESS can2ic         0081h       /* CAN0荞ݐ䃌WX^2     */

    /* -- 荞݋WX^ -- */
    #pragma ADDRESS iio_can0ie     00b9h       /* 荞݋WX^0(IIO9IE) */
    #pragma ADDRESS iio_can1ie     00bah       /* 荞݋WX^1(IIO10IE)*/
    #pragma ADDRESS iio_can2ie     00bbh       /* 荞݋WX^2(IIO11IE)*/

    /* -- 荞ݗvWX^ -- */
    #pragma ADDRESS iio_can0ir     00a9h       /* 荞ݗvWX^0(IIO9IR) */
    #pragma ADDRESS iio_can1ir     00aah       /* 荞ݗvWX^1(IIO10IR)*/
    #pragma ADDRESS iio_can2ir     00abh       /* 荞ݗvWX^2(IIO11IR)*/

#elif CAN_CH == CAN_DRV_CH1
    /* -- CAN -- */
    #pragma ADDRESS can_ctlr0      0280h       /* 䃌WX^                  */
    #pragma ADDRESS can_str        0282h       /* CAN1Xe[^XWX^        */
    #pragma ADDRESS can_idr        0284h       /* CAN1gIDWX^            */
    #pragma ADDRESS can_conr       0286h       /* CAN1oX^C~O䃌WX^*/
    #pragma ADDRESS can_tsr        0288h       /* CAN1^CX^vWX^    */
    #pragma ADDRESS can_tecr       028ah       /* CAN1MG[JEgWX^*/
    #pragma ADDRESS can_recr       028bh       /* CAN1MG[JEgWX^*/
    #pragma ADDRESS can_sistr      028ch       /* CAN1Xbg荞          */
                                               /*            Xe[^XWX^ */

    #pragma ADDRESS can_simkr      0290h       /* CAN1Xbg荞          */
                                               /*                }XNWX^ */
    #pragma ADDRESS can_eimkr      0294h       /* CAN1G[荞            */
                                               /*                }XNWX^ */
    #pragma ADDRESS can_eistr      0295h       /* CAN1G[荞            */
                                               /*            Xe[^XWX^ */
    #pragma ADDRESS can_efr        0296h       /* CAN1G[vWX^        */
    #pragma ADDRESS can_brp        0297h       /* CAN1{[[gvXP[    */
    #pragma ADDRESS can_mdr        0299h       /* CAN1[hWX^            */

    #pragma ADDRESS can_ssctlr     02a0h       /* CAN1VOVbg          */
                                               /*          Rg[WX^ */
    #pragma ADDRESS can_ssstr      02a4h       /* CAN1VOVbg          */
                                               /*            Xe[^XWX^ */


    /* -- }XNWX^ -- */
    #pragma ADDRESS can_gmr        02a8h       /* O[o}XNWX^      */
    #pragma ADDRESS can_lmar       02b0h       /* [J}XNWX^A       */
    #pragma ADDRESS can_lmbr       02b8h       /* [J}XNWX^B       */

    /* -- CANbZ[W䃌WX^ -- */
    #pragma ADDRESS can_mctl       02b0h       /* CAN1bZ[W䃌WX^S*/
    #pragma ADDRESS can_mctl0      02b0h       /* CAN1bZ[W䃌WX^0   */
    #pragma ADDRESS can_mctl1      02b1h       /* CAN1bZ[W䃌WX^1   */
    #pragma ADDRESS can_mctl2      02b2h       /* CAN1bZ[W䃌WX^2   */
    #pragma ADDRESS can_mctl3      02b3h       /* CAN1bZ[W䃌WX^3   */
    #pragma ADDRESS can_mctl4      02b4h       /* CAN1bZ[W䃌WX^4   */
    #pragma ADDRESS can_mctl5      02b5h       /* CAN1bZ[W䃌WX^5   */
    #pragma ADDRESS can_mctl6      02b6h       /* CAN1bZ[W䃌WX^6   */
    #pragma ADDRESS can_mctl7      02b7h       /* CAN1bZ[W䃌WX^7   */
    #pragma ADDRESS can_mctl8      02b8h       /* CAN1bZ[W䃌WX^8   */
    #pragma ADDRESS can_mctl9      02b9h       /* CAN1bZ[W䃌WX^9   */
    #pragma ADDRESS can_mctl10     02bah       /* CAN1bZ[W䃌WX^10  */
    #pragma ADDRESS can_mctl11     02bbh       /* CAN1bZ[W䃌WX^11  */
    #pragma ADDRESS can_mctl12     02bch       /* CAN1bZ[W䃌WX^12  */
    #pragma ADDRESS can_mctl13     02bdh       /* CAN1bZ[W䃌WX^13  */
    #pragma ADDRESS can_mctl14     02beh       /* CAN1bZ[W䃌WX^14  */
    #pragma ADDRESS can_mctl15     02bfh       /* CAN1bZ[W䃌WX^15  */

    /* -- Xbgobt@IWX^ -- */
    #pragma ADDRESS can_sbs        0250h       /* Xbgobt@IWX^  */

    /* -- CAN0䃌WX^1 -- */
    #pragma ADDRESS can_ctlr1      0251h       /* CAN1䃌WX^              */

    /* -- CAN0X[v䃌WX^ -- */
    #pragma ADDRESS can_slpr       0252h       /* CAN1X[v䃌WX^      */

    /* -- CAN0ANZv^XtB^T|[gWX^ -- */
    #pragma ADDRESS can_afs        0254h       /* CAN1ANZv^XtB^    */
                                               /*              T|[gWX^ */
    /* -- bZ[WXbgf[^ -- */
    #pragma ADDRESS can_slot_buf   0260h       /* CAN1ү޽ۯޯ̧           */
    #pragma ADDRESS can_slot_buf0  0260h       /* CAN1ү޽ۯޯ̧0          */
    #pragma ADDRESS can_slot_buf1  0270h       /* CAN1ү޽ۯޯ̧1          */

    /* -- 荞ݐ䃌WX^ -- */
    #pragma ADDRESS can0ic         0075h       /* CAN1荞ݐ䃌WX^0     */
    #pragma ADDRESS can1ic         0095h       /* CAN1荞ݐ䃌WX^1     */
    #pragma ADDRESS can2ic         0099h       /* CAN1荞ݐ䃌WX^2     */

    /* -- 荞݋WX^ -- */
    #pragma ADDRESS iio_can0ie     00b0h       /* 荞݋WX^0(IIO0IE) */
    #pragma ADDRESS iio_can1ie     00b1h       /* 荞݋WX^1(IIO1IE) */
    #pragma ADDRESS iio_can2ie     00b5h       /* 荞݋WX^2(IIO5IE) */

    /* -- 荞ݗvWX^ -- */
    #pragma ADDRESS iio_can0ir     00a0h       /* 荞ݗvWX^0(IIO0IR) */
    #pragma ADDRESS iio_can1ir     00a1h       /* 荞ݗvWX^1(IIO1IR) */
    #pragma ADDRESS iio_can2ir     00a5h       /* 荞ݗvWX^2(IIO5IR) */
#endif

#if CAN_PORT_IN == CAN_DRV_USE_P83
    #pragma ADDRESS can_wkupic     007eh       /* CAN0Wakeup荞ݗp          */
                                               /*        䃌WX^(INT1IC)   */
    #pragma ADDRESS can_ifsr       031fh       /* OݗvIWX^     */
#elif CAN_PORT_IN == CAN_DRV_USE_P77
    #pragma ADDRESS can_wkupic     008eh       /* CAN0Wakeup荞ݗp          */
                                               /*        䃌WX^(TA3IC)    */
    /* -- Wakeupp^C}WX^ -- */
    #pragma ADDRESS can_ta3mr      0359h       /* ^C}A3[hWX^         */
    #pragma ADDRESS can_ta3        034ch       /* ^C}A3WX^               */
    #pragma ADDRESS can_trgsr      0343h       /* gKIWX^             */
    #pragma ADDRESS can_tabsr      0340h       /* JEgJntO             */
#else
    /* P77/P83ȊOI(`Ȃ) */
#endif

/* ʐݒ */
/* veNg֘A */
#pragma ADDRESS can_prcr       000Ah       /* veNgWX^            */
/* -- @\IWX^A0 -- */
#pragma ADDRESS can_ps0        03b0h       /* @\IWX^A1             */
/* -- @\IWX^A1 -- */
#pragma ADDRESS can_ps1        03b1h       /* @\IWX^A1             */
/* -- @\IWX^A2 -- */
#pragma ADDRESS can_ps2        03b4h       /* @\IWX^A2             */
/* -- @\IWX^A3 -- */
#pragma ADDRESS can_ps3        03b5h       /* @\IWX^A3             */
/* -- @\IWX^B0 -- */
#pragma ADDRESS can_psl0       03b2h       /* @\IWX^B1             */
/* -- @\IWX^B1 -- */
#pragma ADDRESS can_psl1       03b3h       /* @\IWX^B1             */
/* -- @\IWX^B2 -- */
#pragma ADDRESS can_psl2       03b6h       /* @\IWX^B2             */
/* -- @\IWX^B3 -- */
#pragma ADDRESS can_psl3       03b7h       /* @\IWX^B3             */
/* -- @\IWX^C -- */
#pragma ADDRESS can_psc        03afh       /* @\IWX^C              */
/* -- @\IWX^C2 -- */
#pragma ADDRESS can_psc2       03ach       /* @\IWX^C2             */
/* -- @\IWX^C3 -- */
#pragma ADDRESS can_psc3       03adh       /* @\IWX^C3             */
/* -- ͋@\IWX^ -- */
#pragma ADDRESS can_ips        0178h       /* ͋@\IWX^           */
/* -- ͋@\IWX^A -- */
#pragma ADDRESS can_ipsa       0179h       /* ͋@\IWX^A          */

/* -- P6WX^ -- */
#pragma ADDRESS can_p6         03c0h       /* P6WX^                     */
/* -- P6WX^ -- */
#pragma ADDRESS can_pd6        03c2h       /* P6WX^                 */
/* -- P7WX^ -- */
#pragma ADDRESS can_p7         03c1h       /* P7WX^                     */
/* -- P7WX^ -- */
#pragma ADDRESS can_pd7        03c3h       /* P7WX^                 */
/* -- P8WX^ -- */
#pragma ADDRESS can_p8         03c4h       /* P8WX^                     */
/* -- P8WX^ -- */
#pragma ADDRESS can_pd8        03c6h       /* P8WX^                 */
/* -- P9WX^ -- */
#pragma ADDRESS can_p9         03c5h       /* P9WX^                     */
/* -- P9WX^ -- */
#pragma ADDRESS can_pd9        03c7h       /* P9WX^                 */

/*---------------------------------------------------------------------------*/
/*  CAN0 䃌WX^ 0                                                      */
/*---------------------------------------------------------------------------*/
typedef union _can_ctrl0_reg{
    struct{                               /* bit ANZX                    */
        UINT8      reset0       :1;         /* Full CAN۰ؾޯ0         */
        UINT8      loopback     :1;         /* ٰޯӰޑIޯ            */
        UINT8      not_use1     :1;         /* -zuĂȂ-          */
        UINT8      basiccan     :1;         /* BasicCANӰޑIޯ            */
        UINT8      reset1       :1;         /* Full CAN۰ؾޯ1         */
        UINT8      not_use2     :3;         /* ذӰޑIޯ               */
        UINT8      tsprescale   :2;         /* ѽߗpؽ               */
        UINT8      tsreset      :1;         /* ѽ߶pؾޯ          */
        UINT8      ecreset      :1;         /* װpؾޯ               */
        UINT8      not_use3     :4;         /* -zuĂȂ-          */
    } bit;
    CAN_BYTE_HL   byte;                   /* byte ANZX                   */
    UINT16    word;                         /* word ANZX                   */
}CAN_CTRL0RGT;

extern CAN_CTRL0RGT can_ctlr0;

/*---------------------------------------------------------------------------*/
/*  CAN0 䃌WX^ 1                                                      */
/*---------------------------------------------------------------------------*/
typedef union _can_ctrl1_reg{
    struct{                               /* bit ANZX                    */
        UINT8      not_use1     :3;         /* -zuĂȂ-          */
        UINT8      banksel      :1;         /* oN؂ւrbg            */
        UINT8      not_use2     :2;         /* -zuĂȂ-          */
        UINT8      intsel       :1;         /* 荞݃[hIrbg        */
        UINT8      not_use3     :1;         /* -zuĂȂ-          */
    } bit;
    UINT8   byte;                           /* byte ANZX                   */
}CAN_CTRL1RGT;

extern CAN_CTRL1RGT can_ctlr1;

/*---------------------------------------------------------------------------*/
/*  CAN0 Xe[^XWX^                                                  */
/*---------------------------------------------------------------------------*/
typedef union _can_str_rgt {
    struct {                              /* bit ANZX                    */
        UINT8   mbox            :4;         /* ANeBuXbgʃrbg    */
        UINT8   trmsucc         :1;         /* MXe[^X              */
        UINT8   recsucc         :1;         /* MXe[^X              */
        UINT8   trmstate        :1;         /* MXe[^X                  */
        UINT8   recstate        :1;         /* MXe[^X                  */
        UINT8   state_reset     :1;         /* CAN ZbgXe[^X          */
        UINT8   state_loopback  :1;         /* [vobNXe[^X          */
        UINT8   not_use1        :1;         /* - zuĂȂ -        */
        UINT8   state_basiccan  :1;         /* Basic CAN Xe[^X            */
        UINT8   state_buserror  :1;         /* CANoXG[                   */
        UINT8   state_errpas    :1;         /* G[pbVuXe[^X        */
        UINT8   state_busoff    :1;         /* oXItXe[^X              */
        UINT8   not_use2        :1;         /* - zuĂȂ -        */
    } bit;
    CAN_BYTE_HL byte;                     /* byte ANZX                   */
    UINT16      word;                       /* word ANZX                   */
}CAN_STRRGT;

extern CAN_STRRGT can_str;

/*---------------------------------------------------------------------------*/
/*  CAN0Xbg荞݃Xe[^XWX^                                   */
/*---------------------------------------------------------------------------*/
typedef union _can_sistr_rgt {
    struct {                                /* bit ANZX                  */
        UINT8   slot15_sistr      :1;         /* Xbg15荞݋rbg  */
        UINT8   slot14_sistr      :1;         /* Xbg14荞݋rbg  */
        UINT8   slot13_sistr      :1;         /* Xbg13荞݋rbg  */
        UINT8   slot12_sistr      :1;         /* Xbg12荞݋rbg  */
        UINT8   slot11_sistr      :1;         /* Xbg11荞݋rbg  */
        UINT8   slot10_sistr      :1;         /* Xbg10荞݋rbg  */
        UINT8   slot9_sistr       :1;         /* Xbg9荞݋rbg   */
        UINT8   slot8_sistr       :1;         /* Xbg8荞݋rbg   */
        UINT8   slot7_sistr       :1;         /* Xbg7荞݋rbg   */
        UINT8   slot6_sistr       :1;         /* Xbg6荞݋rbg   */
        UINT8   slot5_sistr       :1;         /* Xbg5荞݋rbg   */
        UINT8   slot4_sistr       :1;         /* Xbg4荞݋rbg   */
        UINT8   slot3_sistr       :1;         /* Xbg3荞݋rbg   */
        UINT8   slot2_sistr       :1;         /* Xbg2荞݋rbg   */
        UINT8   slot1_sistr       :1;         /* Xbg1荞݋rbg   */
        UINT8   slot0_sistr       :1;         /* Xbg0荞݋rbg   */
    } bit;
    CAN_BYTE_HL byte;                       /* byte ANZX                 */
    UINT16      word;                         /* word ANZX                 */
}CAN_SISTRRGT;

extern CAN_SISTRRGT can_sistr;

/*---------------------------------------------------------------------------*/
/*  CAN0Xbg荞݃}XNWX^                                       */
/*---------------------------------------------------------------------------*/
typedef union _can_simkr_rgt {
    struct {                                /* bit ANZX                  */
        UINT8   slot15_simkr      :1;         /* Xbg15荞݋rbg  */
        UINT8   slot14_simkr      :1;         /* Xbg14荞݋rbg  */
        UINT8   slot13_simkr      :1;         /* Xbg13荞݋rbg  */
        UINT8   slot12_simkr      :1;         /* Xbg12荞݋rbg  */
        UINT8   slot11_simkr      :1;         /* Xbg11荞݋rbg  */
        UINT8   slot10_simkr      :1;         /* Xbg10荞݋rbg  */
        UINT8   slot9_simkr       :1;         /* Xbg9荞݋rbg   */
        UINT8   slot8_simkr       :1;         /* Xbg8荞݋rbg   */
        UINT8   slot7_simkr       :1;         /* Xbg7荞݋rbg   */
        UINT8   slot6_simkr       :1;         /* Xbg6荞݋rbg   */
        UINT8   slot5_simkr       :1;         /* Xbg5荞݋rbg   */
        UINT8   slot4_simkr       :1;         /* Xbg4荞݋rbg   */
        UINT8   slot3_simkr       :1;         /* Xbg3荞݋rbg   */
        UINT8   slot2_simkr       :1;         /* Xbg2荞݋rbg   */
        UINT8   slot1_simkr       :1;         /* Xbg1荞݋rbg   */
        UINT8   slot0_simkr       :1;         /* Xbg0荞݋rbg   */
    } bit;
    CAN_BYTE_HL byte;                       /* byte ANZX                 */
    UINT16      word;                         /* word ANZX                 */
}CAN_SIMKRRGT;

extern CAN_SIMKRRGT can_simkr;

/*---------------------------------------------------------------------------*/
/*  CAN0G[荞݃Xe[^XWX^                                     */
/*---------------------------------------------------------------------------*/
typedef union _can_eistr_rgt {
    struct {                              /* bit ANZX                    */
        UINT8   bois              :1;       /* oXIt荞݃Xe[^Xrbg*/
        UINT8   epis              :1;       /* pbVu荞݃Xe[^Xrbg*/
        UINT8   beis              :1;       /* BusError荞݃Xe[^Xrbg*/
        UINT8   not_use1          :5;       /* - zuĂȂ -        */
    } bit;
    UINT8 byte;                             /* byte ANZX                   */
}CAN_EISTRRGT;

extern CAN_EISTRRGT can_eistr;

/*---------------------------------------------------------------------------*/
/*  CAN0G[荞݃}XNWX^                                         */
/*---------------------------------------------------------------------------*/
typedef union _can_eimkr_rgt {
    struct {                              /* bit ANZX                    */
        UINT8   boim              :1;       /* oXIt荞݃Xe[^Xrbg*/
        UINT8   epim              :1;       /* pbVu荞݃Xe[^Xrbg*/
        UINT8   beim              :1;       /* BusError荞݃Xe[^Xrbg*/
        UINT8   not_use1          :5;       /* - zuĂȂ -        */
    } bit;
    UINT8 byte;                             /* byte ANZX                   */
}CAN_EIMKRRGT;

extern CAN_EIMKRRGT can_eimkr;

/*---------------------------------------------------------------------------*/
/*  CAN0VOVbg䃌WX^                                         */
/*---------------------------------------------------------------------------*/
typedef union _can_ssctlr_rgt {
    struct {                              /* bit ANZX                    */
        UINT8  slot15_ssctlr   :1;          /* Xbg15SingleShotrbg  */
        UINT8  slot14_ssctlr   :1;          /* Xbg14SingleShotrbg  */
        UINT8  slot13_ssctlr   :1;          /* Xbg13SingleShotrbg  */
        UINT8  slot12_ssctlr   :1;          /* Xbg12SingleShotrbg  */
        UINT8  slot11_ssctlr   :1;          /* Xbg11SingleShotrbg  */
        UINT8  slot10_ssctlr   :1;          /* Xbg10SingleShotrbg  */
        UINT8  slot9_ssctlr    :1;          /* Xbg9SingleShotrbg   */
        UINT8  slot8_ssctlr    :1;          /* Xbg8SingleShotrbg   */
        UINT8  slot7_ssctlr    :1;          /* Xbg7SingleShotrbg   */
        UINT8  slot6_ssctlr    :1;          /* Xbg6SingleShotrbg   */
        UINT8  slot5_ssctlr    :1;          /* Xbg5SingleShotrbg   */
        UINT8  slot4_ssctlr    :1;          /* Xbg4SingleShotrbg   */
        UINT8  slot3_ssctlr    :1;          /* Xbg3SingleShotrbg   */
        UINT8  slot2_ssctlr    :1;          /* Xbg2SingleShotrbg   */
        UINT8  slot1_ssctlr    :1;          /* Xbg1SingleShotrbg   */
        UINT8  slot0_ssctlr    :1;          /* Xbg0SingleShotrbg   */
    } bit;
    CAN_BYTE_HL byte;                     /* byte ANZX                   */
    UINT16      word;                       /* word ANZX                   */
}CAN_SSCTLRRGT;

extern CAN_SSCTLRRGT can_ssctlr;

/*---------------------------------------------------------------------------*/
/*  CAN0VOVbgXe[^XWX^                                   */
/*---------------------------------------------------------------------------*/
typedef union _can_ssstr_rgt {
    struct {                              /* bit ANZX                    */
        UINT8  slot15_ssstr    :1;          /* Xbg15SingleShotStatusrbg*/
        UINT8  slot14_ssstr    :1;          /* Xbg14SingleShotStatusrbg*/
        UINT8  slot13_ssstr    :1;          /* Xbg13SingleShotStatusrbg*/
        UINT8  slot12_ssstr    :1;          /* Xbg12SingleShotStatusrbg*/
        UINT8  slot11_ssstr    :1;          /* Xbg11SingleShotStatusrbg*/
        UINT8  slot10_ssstr    :1;          /* Xbg10SingleShotStatusrbg*/
        UINT8  slot9_ssstr     :1;          /* Xbg9SingleShotStatusrbg */
        UINT8  slot8_ssstr     :1;          /* Xbg8SingleShotStatusrbg */
        UINT8  slot7_ssstr     :1;          /* Xbg7SingleShotStatusrbg */
        UINT8  slot6_ssstr     :1;          /* Xbg6SingleShotStatusrbg */
        UINT8  slot5_ssstr     :1;          /* Xbg5SingleShotStatusrbg */
        UINT8  slot4_ssstr     :1;          /* Xbg4SingleShotStatusrbg */
        UINT8  slot3_ssstr     :1;          /* Xbg3SingleShotStatusrbg */
        UINT8  slot2_ssstr     :1;          /* Xbg2SingleShotStatusrbg */
        UINT8  slot1_ssstr     :1;          /* Xbg1SingleShotStatusrbg */
        UINT8  slot0_ssstr     :1;          /* Xbg0SingleShotStatusrbg */
    } bit;
    CAN_BYTE_HL byte;                     /* byte ANZX                   */
    UINT16      word;                       /* word ANZX                   */
}CAN_SSSTRRGT;

extern CAN_SSSTRRGT can_ssstr;

/*---------------------------------------------------------------------------*/
/*  CAN0G[vWX^                                                   */
/*---------------------------------------------------------------------------*/
typedef union _can_efr_rgt{
    struct {                              /* bit ANZX                    */
        UINT8  acke        :1;              /* ACKG[orbg             */
        UINT8  crce        :1;              /* CRCG[orbg             */
        UINT8  forme       :1;              /* tH[G[orbg        */
        UINT8  stfe        :1;              /* X^btG[orbg        */
        UINT8  bite0       :1;              /* rbgG[orbg0         */
        UINT8  bite1       :1;              /* rbgG[orbg1         */
        UINT8  rcve        :1;              /* MG[orbg            */
        UINT8  tre         :1;              /* MG[orbg            */
    } bit;
    UINT8 byte;                             /* byte ANZX                   */
} CAN_EFRRGT;

extern CAN_EFRRGT can_efr;

/*---------------------------------------------------------------------------*/
/*  CAN0[hWX^                                                       */
/*---------------------------------------------------------------------------*/
typedef union _can_mdr_rgt {
    struct {                              /* bit ANZX                    */
        UINT8   cmod              :2;       /* 샂[hIrbg            */
        UINT8   not_use1          :6;       /* - zuĂȂ -        */
    } bit;
    UINT8 byte;                             /* byte ANZX                   */
}CAN_MDRRGT;

extern CAN_MDRRGT can_mdr;

/*---------------------------------------------------------------------------*/
/*  CAN0gIDWX^                                                       */
/*---------------------------------------------------------------------------*/
typedef union _can_idr_rgt {
    struct {                              /* bit ANZX                    */
        UINT8  slot15_idr      :1;          /* Xbg15荞݋rbg    */
        UINT8  slot14_idr      :1;          /* Xbg14荞݋rbg    */
        UINT8  slot13_idr      :1;          /* Xbg13荞݋rbg    */
        UINT8  slot12_idr      :1;          /* Xbg12荞݋rbg    */
        UINT8  slot11_idr      :1;          /* Xbg11荞݋rbg    */
        UINT8  slot10_idr      :1;          /* Xbg10荞݋rbg    */
        UINT8  slot9_idr       :1;          /* Xbg9荞݋rbg     */
        UINT8  slot8_idr       :1;          /* Xbg8荞݋rbg     */
        UINT8  slot7_idr       :1;          /* Xbg7荞݋rbg     */
        UINT8  slot6_idr       :1;          /* Xbg6荞݋rbg     */
        UINT8  slot5_idr       :1;          /* Xbg5荞݋rbg     */
        UINT8  slot4_idr       :1;          /* Xbg4荞݋rbg     */
        UINT8  slot3_idr       :1;          /* Xbg3荞݋rbg     */
        UINT8  slot2_idr       :1;          /* Xbg2荞݋rbg     */
        UINT8  slot1_idr       :1;          /* Xbg1荞݋rbg     */
        UINT8  slot0_idr       :1;          /* Xbg0荞݋rbg     */
    } bit;
    CAN_BYTE_HL byte;                     /* byte ANZX                   */
    UINT16      word;                       /* word ANZX                   */
}CAN_IDRRGT;

extern CAN_IDRRGT can_idr;

/*---------------------------------------------------------------------------*/
/*  CAN0oX^C~O䃌WX^                                           */
/*---------------------------------------------------------------------------*/
typedef union _can_conr_rgt{
    struct {                              /* bit ANZX                    */
        UINT8  not_use1    :4;              /* - zuĂȂ -        */
        UINT8  sam         :1;              /* ݸމ񐔐ݒޯ            */
        UINT8  pts         :3;              /* Propagation Time Segment        */
        UINT8  pbs1        :3;              /* Phase Buffer Segment 1          */
        UINT8  pbs2        :3;              /* Phase Buffer Segment 2          */
        UINT8  sjw         :2;              /* Re Synchronization Jump Width   */
    } bit;
    CAN_BYTE_HL byte;                     /* byte ANZX                   */
    UINT16      word;                       /* word ANZX                   */
} CAN_CONRRGT;

extern CAN_CONRRGT can_conr;

/*---------------------------------------------------------------------------*/
/*  CAN0 {[[gvXP[                                              */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can_brp;

/*---------------------------------------------------------------------------*/
/*  CAN0 MG[JEgWX^                                          */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can_tecr;

/*---------------------------------------------------------------------------*/
/*  CAN0 MG[JEgWX^                                          */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can_recr;

/*---------------------------------------------------------------------------*/
/*  CAN0 }XNWX^                                                      */
/*---------------------------------------------------------------------------*/
typedef union _can_mask_rgt {
    struct can_mask_byte_def {
        UINT8  sidh;                        /* WID 10` 6                   */
        UINT8  sidl;                        /* WID  5` 0                   */
        UINT8  eidh;                        /* gID 17`14                   */
        UINT8  eidm;                        /* gID 13` 6                   */
        UINT8  eidl;                        /* gID  5` 0                   */
    } byte;
} CAN_MASKRGT;

extern CAN_MASKRGT can_gmr;
extern CAN_MASKRGT can_lmar;
extern CAN_MASKRGT can_lmbr;

/*---------------------------------------------------------------------------*/
/*  CAN0 bZ[WXbg䃌WX^                                      */
/*---------------------------------------------------------------------------*/
typedef union _can_mctl_rgt {
    struct {                              /* bit ANZXFM            */
        UINT8  newdata     :1;              /* MXe[^XtO        */
        UINT8  invaldata   :1;              /* MXe[^XtO            */
        UINT8  msglost     :1;              /* I[o[CgtO            */
        UINT8  remactive   :1;              /* [gt[Mð׸ */
        UINT8  rsplock     :1;              /* ֎~[hIrbg    */
        UINT8  remote      :1;              /* [gt[ݒrbg      */
        UINT8  recreq      :1;              /* Mvrbg                  */
        UINT8  trmreq      :1;              /* Mvrbg                  */
    } rec;
    struct {                              /* bit ANZXFM            */
        UINT8  sentdata    :1;              /* MXe[^XtO        */
        UINT8  trmactive   :1;              /* MXe[^XtO            */
        UINT8  msglost     :1;              /* I[o[CgtO            */
        UINT8  remactive   :1;              /* [gt[Mð׸ */
        UINT8  rsplock     :1;              /* ֎~[hIrbg    */
        UINT8  remote      :1;              /* [gt[ݒrbg      */
        UINT8  recreq      :1;              /* Mvrbg                  */
        UINT8  trmreq      :1;              /* Mvrbg                  */
    } trm;
    UINT8      byte;                        /* byte ANZX                   */
} CAN_MCTLRGT;

extern CAN_MCTLRGT can_mctl[16];

/*---------------------------------------------------------------------------*/
/*  CAN0 bZ[WXbgobt@f[^                                    */
/*---------------------------------------------------------------------------*/
typedef union _can_slot_rgt {
    struct {
        UINT8  sidh;                        /* WID 10 `  6                 */
        UINT8  sidl;                        /* WID  5 `  0                 */
        UINT8  eidh;                        /* gID 17 ` 14                 */
        UINT8  eidm;                        /* gID 13 `  6                 */
        UINT8  eidl;                        /* gID  5 `  0                 */
        UINT8  dlc;                         /* f[^                        */
        UINT8  data[8];                     /* f[^ ( 8byte )                */
        UINT8  tsh;                         /* ^CX^v ( High )         */
        UINT8  tsl;                         /* ^CX^v ( Low  )         */
    } byte;
    UINT8   byte16[16];
    UINT16  word8[8];
} CAN_SLOTRGT;

extern CAN_SLOTRGT can_slot_buf0;
extern CAN_SLOTRGT can_slot_buf1;

/*---------------------------------------------------------------------------*/
/*  CAN0Xbgobt@IWX^                                         */
/*---------------------------------------------------------------------------*/
typedef union _can_sbs_rgt {
    struct {                              /* bit ANZX                    */
        UINT8  sbs0               :4;       /* Xbgobt@0ԍIrbg */
        UINT8  sbs1               :4;       /* Xbgobt@1ԍIrbg */
    } bit;
    UINT8 byte;                             /* byte ANZX                   */
}CAN_SBSRGT;

extern CAN_SBSRGT can_sbs;

/*---------------------------------------------------------------------------*/
/*  CAN0X[vWX^                                                     */
/*---------------------------------------------------------------------------*/
typedef union _can_slpr_rgt {
    struct {                              /* bit ANZX                    */
        UINT8   sleep             :1;       /* X[v[hrbg        */
        UINT8   not_use1          :7;       /* - zuĂȂ -        */
    } bit;
    UINT8 byte;                             /* byte ANZX                   */
}CAN_SLPRRGT;

extern CAN_SLPRRGT can_slpr;

/*---------------------------------------------------------------------------*/
/*  veNgWX^                                                       */
/*---------------------------------------------------------------------------*/
typedef struct _can_prcr_rgt {
    struct {                              /* bit ANZX                    */
        UINT8  prc0        :1;              /* veNgrbg 0              */
        UINT8  prc1        :1;              /* veNgrbg 1              */
        UINT8  prc2        :1;              /* veNgrbg 2              */
        UINT8  reserved    :3;              /*  - \rbg -                 */
        UINT8  not_use     :2;              /*  - zuĂȂ -       */
    } bit;
    UINT8      byte;                        /* byte ANZX                   */
} CAN_PRCRRGT;

extern CAN_PRCRRGT can_prcr;

/*---------------------------------------------------------------------------*/
/*  CAN0ANZv^XtB^[T|[gjbgWX^                     */
/*---------------------------------------------------------------------------*/
typedef union _can_c0afs_rgt {
    struct {                                /* bit ANZX                  */
        UINT8  sid6        :1;                /* WID 6                      */
        UINT8  sid7        :1;                /* WID 7                      */
        UINT8  sid8        :1;                /* WID 8                      */
        UINT8  sid9        :1;                /* WID 9                      */
        UINT8  sid10       :1;                /* WID 10                     */
        UINT8  dummy01     :1;                /* _~[rbg 1                */
        UINT8  dummy02     :1;                /* _~[rbg 2                */
        UINT8  dummy03     :1;                /* _~[rbg 3                */
        UINT8  sid0        :1;                /* WID 0                      */
        UINT8  sid1        :1;                /* WID 1                      */
        UINT8  sid2        :1;                /* WID 2                      */
        UINT8  sid3        :1;                /* WID 3                      */
        UINT8  sid4        :1;                /* WID 4                      */
        UINT8  sid5        :1;                /* WID 5                      */
        UINT8  dummy04     :1;                /* _~[rbg 4                */
        UINT8  dummy05     :1;                /* _~[rbg 5                */
    } bit;
    CAN_BYTE_HL   byte;                     /* byte ANZX                 */
    UINT16      word;                         /* word ANZX                 */
} CAN_C0AFS;

extern CAN_C0AFS can_afs;

/*---------------------------------------------------------------------------*/
/*  CAN荞ݐ䃌WX^0                                                 */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can0ic ;

/*---------------------------------------------------------------------------*/
/*  CAN荞ݐ䃌WX^1                                                 */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can1ic ;

/*---------------------------------------------------------------------------*/
/*  CAN荞ݐ䃌WX^2                                                 */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can2ic ;

/*---------------------------------------------------------------------------*/
/*  CAN荞݋WX^0                                                 */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF iio_can0ie ;

/*---------------------------------------------------------------------------*/
/*  CAN荞݋WX^1                                                 */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF iio_can1ie ;

/*---------------------------------------------------------------------------*/
/*  CAN荞݋WX^2                                                 */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF iio_can2ie ;

/*---------------------------------------------------------------------------*/
/*  CAN荞݋WX^2                                                 */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF iio_can0ir ;

/*---------------------------------------------------------------------------*/
/*  CAN荞ݗvWX^2                                                 */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF iio_can1ir ;

/*---------------------------------------------------------------------------*/
/*  CAN荞ݗvWX^2                                                 */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF iio_can2ir ;

/*---------------------------------------------------------------------------*/
/*  CANoXIt荞ݐ䃌WX^                                          */
/*---------------------------------------------------------------------------*/
#if (CAN_PORT_IN == CAN_DRV_USE_P83) || (CAN_PORT_IN == CAN_DRV_USE_P77)
    extern union CAN_BYTEDEF can_wkupic ;
#endif

/*---------------------------------------------------------------------------*/
/*  P6WX^                                                               */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can_p6;

/*---------------------------------------------------------------------------*/
/*  P6WX^                                                           */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can_pd6;

/*---------------------------------------------------------------------------*/
/*  P7WX^                                                               */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can_p7;

/*---------------------------------------------------------------------------*/
/*  P7WX^                                                           */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can_pd7;

/*---------------------------------------------------------------------------*/
/*  P8WX^                                                               */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can_p8;

/*---------------------------------------------------------------------------*/
/*  P8WX^                                                           */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can_pd8;

/*---------------------------------------------------------------------------*/
/*  P9WX^                                                               */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can_p9;

/*---------------------------------------------------------------------------*/
/*  P9WX^                                                           */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can_pd9;

/*---------------------------------------------------------------------------*/
/*  @\IWX^A0                                                       */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can_ps0;          /* @\IWX^A0             */

/*---------------------------------------------------------------------------*/
/*  @\IWX^A1                                                       */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can_ps1;          /* @\IWX^A1             */

/*---------------------------------------------------------------------------*/
/*  @\IWX^A2                                                       */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can_ps2;          /* @\IWX^A2             */

/*---------------------------------------------------------------------------*/
/*  @\IWX^A3                                                       */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can_ps3;          /* @\IWX^A3             */

/*---------------------------------------------------------------------------*/
/*  @\IWX^B0                                                       */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can_psl0;         /* @\IWX^B0             */

/*---------------------------------------------------------------------------*/
/*  @\IWX^B1                                                       */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can_psl1;         /* @\IWX^B1             */

/*---------------------------------------------------------------------------*/
/*  @\IWX^B2                                                       */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can_psl2;         /* @\IWX^B2             */

/*---------------------------------------------------------------------------*/
/*  @\IWX^B3                                                       */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can_psl3;         /* @\IWX^B3             */

/*---------------------------------------------------------------------------*/
/*  @\IWX^C                                                        */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can_psc;          /* @\IWX^C              */

/*---------------------------------------------------------------------------*/
/*  @\IWX^C2                                                       */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can_psc2;         /* @\IWX^C2             */

/*---------------------------------------------------------------------------*/
/*  @\IWX^C3                                                       */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can_psc3;         /* @\IWX^C3             */

/*---------------------------------------------------------------------------*/
/*  ͋@\IWX^                                                     */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can_ips;          /* ͋@\IWX^           */

/*---------------------------------------------------------------------------*/
/*  ͋@\IWX^A                                                    */
/*---------------------------------------------------------------------------*/
extern union CAN_BYTEDEF can_ipsa;         /* ͋@\IWX^A          */

#if CAN_PORT_IN == CAN_DRV_USE_P77
    /*---------------------------------------------------------------------------*/
    /*  TA3[hWX^                                                        */
    /*---------------------------------------------------------------------------*/
    extern union CAN_BYTEDEF can_ta3mr;
    /*---------------------------------------------------------------------------*/
    /*  TA3^C}WX^                                                        */
    /*---------------------------------------------------------------------------*/
    extern union CAN_WORDDEF can_ta3;
    /*---------------------------------------------------------------------------*/
    /*  ^C}gKIWX^                                                 */
    /*---------------------------------------------------------------------------*/
    extern union CAN_BYTEDEF can_trgsr;
    /*---------------------------------------------------------------------------*/
    /*  ^C}JEgX^[gtO                                             */
    /*---------------------------------------------------------------------------*/
    extern union CAN_BYTEDEF can_tabsr;

#elif CAN_PORT_IN == CAN_DRV_USE_P83
    /*---------------------------------------------------------------------------*/
    /*  OݗvIWX^                                               */
    /*---------------------------------------------------------------------------*/
    extern union CAN_BYTEDEF can_ifsr;
    
#else
    /* P77/P83ȊOI(`Ȃ) */
#endif

#endif /* __CAN_DRV_SFR_H_INCLUDE__ */
/****** End of File **********************************************************/

