/*
 *	TOPPERS NonOS CAN Middleware
 *		Toyohashi Open Platform for Embedded Real-Time Systems
 *		NonOS CAN Middleware
 * 
 *	Copyright (C) 2007 Sunny Giken Inc.
 * 
 *	L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *	ɂČ\Ă GNU General Public License  Version 2 ɋL
 *	qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *	ς̂܂ށDȉjgpEEρEĔzziȉC
 *	pƌĂԁj邱Ƃ𖳏ŋD
 *	(1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *		\C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *		XR[hɊ܂܂Ă邱ƁD
 *	(2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *		pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *		҃}jAȂǁjɁCL̒쌠\C̗pщL
 *		̖ۏ؋Kfڂ邱ƁD
 *	(3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *		płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *		ƁD
 *	  (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *		  쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *	  (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *		  񍐂邱ƁD
 *	(4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *		QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *	{\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *	TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *	܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *	ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */
/*
 *@Version 1.00  2007.10.26
 */

#ifndef __CAN_COM_EXT_H_INCLUDE__
#define __CAN_COM_EXT_H_INCLUDE__

/*---------------------------------------------------------------------------*/
/* ft@C`                                                            */
/*---------------------------------------------------------------------------*/
/* COM萔 */
#define CAN_COM_STP     ((UINT8)(0x00))                   /* COM~       */
#define CAN_COM_RCVONLY ((UINT8)(0x0C))                   /* COMM   */
#define CAN_COM_WAITING ((UINT8)(0x0D))                   /* COMM֎~   */
#define CAN_COM_NML     ((UINT8)(0x0F))                   /* COMS쒆   */

/* ME֎~Ԓ萔 */
#define CAN_COM_SND_OFF                 ((UINT8)(0))      /* M֎~    */
#define CAN_COM_SND_ON                  ((UINT8)(1))      /* M    */

/* COM샂[h */
#define CAN_COM_MODE_MASK               ((UINT8)(0x0F))   /* COMXe[^XM̂݌o */

/* COMJE^萔 */
#define CAN_COM_POWER_ON                ((UINT8)(0))      /* d      */
#define CAN_COM_SLEEP                   ((UINT8)(1))      /* Sleepڍs     */
#define CAN_COM_BUSOFF                  ((UINT8)(2))      /* oXIt      */
#define CAN_COM_SNDSTOP                 ((UINT8)(3))      /* Mr⎞      */
#define CAN_COM_TWBSNORMAL              ((UINT8)(4))      /* NMTwbsNormalԎ */
#define CAN_COM_BUSOTHER                ((UINT8)(5))      /* AALŎgp(̑w莞) */

/* SendMessage֐œnꂽbZ[Ẅ */
#define CAN_PERIODIC_MSG                ((UINT8)(0x00))   /* bZ[W͎M         */
#define CAN_EVENT_MSG                   ((UINT8)(0x01))   /* bZ[W̓CxgM     */

/* DLC`FbN萔 */
#define CAN_COM_GET_DATA_8BYTE          ((UINT8)(0))      /* 8oCgSăf[^荞        */
#define CAN_COM_GET_DATA_AND_0          ((UINT8)(1))      /* Mf[^ȍ~0Ŗ߂        */
#define CAN_COM_GET_DATA_ONLY           ((UINT8)(2))      /* Mf[^̂ݎ荞       */
#define CAN_COM_GET_DATA_CANCEL         ((UINT8)(3))      /* Mf[^j         */

/* ԗʒʐMdlp萔 */
#define CAN_COM_DATAID_IS_CANID         ((UINT8)(0))      /* f[^IDCAN-ID             */
#define CAN_COM_DATAID_IS_DATA          ((UINT8)(1))      /* f[^ID̓f[^̂PoCg */

#define CAN_COM_NO_MODE                 ((UINT8)(0))      /* MȂ             */
#define CAN_COM_EVENT_MODE              ((UINT8)(1))      /* CxgM         */
#define CAN_COM_PERIODIC_MODE           ((UINT8)(2))      /* M             */
#define CAN_COM_EVENT_PERIODIC_MODE     ((UINT8)(3))      /* CxgM     */
#define CAN_COM_CHGSND_PERIODIC_MODE    ((UINT8)(4))      /* CxgM     */

/* ɰފĎp */
#define CAN_COM_NO_USE ((UINT16)0xFFFF)

/*---------------------------------------------------------------------------*/
/*  ^`                                                                   */
/*---------------------------------------------------------------------------*/
/* f[^IDʐM */
struct snddata_bit_def_8{
    UINT8     locked:1;           /* M                      */
    UINT8     ok:1;               /* 푗M                            */
    UINT8     backup:1;           /* ML[tɂobNAbv    */
    UINT8     limit:1;            /* ML[tɂ著Ms        */
    UINT8     ng:1;               /* Ms                            */
    UINT8     cond:1;             /* M/֎~ */
    UINT8     tblvalid:1;         /* ԗʒʐMdle[ũf[^OK  */
    UINT8     dummy:1;
};

struct rcvdata_bit_def_8{
    UINT8     rcv:1;              /* NAM                        */
    UINT8     newdata:1;          /* PԁAMM                  */
    UINT8     silent:1;           /* Mr                            */
    UINT8     ng:1;               /* Ms                            */
    UINT8     pwon:1;             /* NԃtO                        */
    UINT8     dummy:3;
};

typedef union{
    struct snddata_bit_def_8    snddata;
    struct rcvdata_bit_def_8    rcvdata;
    UINT8  byte;
}CANAPIDataStsType;

typedef struct{
    CANAPIDataStsType sts;         /* Xe[^X                             */
}COMRcvDataStsType;

/* COMʐM */
typedef union{
    struct{
        UINT8     en_sndque:1;            /* ML[                  */
        UINT8     en_snd:1;               /* M                        */
        UINT8     en_rcvque:1;            /* ML[                  */
        UINT8     en_rcv:1;               /* M                        */
        UINT8     sndstop:1;              /* Mr                    */
        UINT8     rcvstop:1;              /* Mr                    */
        UINT8     dummy:2;
    }bit;
    UINT8 byte;
}COMStsType;

/* ԗʒʐMdl֘A */
typedef struct{                         /* CAN-IDƃf[^ID̊֘A            */
    UINT16    can_id;                   /* CAN-ID                            */
    UINT8     pos;                      /* f[^ID̏ꏊ                    */
}CANIDType;

typedef struct{                         /* Mf[^֘A                    */
    UINT16    data_id;                  /* f[^ID                          */
    UINT8     dlc;                      /* DLC                               */
    UINT16    mask;                     /* ECUN̎MC^[o
                                                        }XN(ms)       */
    UINT16    interval;                 /* MC^[o臒l(ms)          */

    UINT8     dlc_size_over;            /* DLCTCY𒴂ꍇ̃f[^擾 */
    UINT8     dlc_size_under;           /* DLCTCY̏ꍇ̃f[^擾   */
    DataType  def;                      /* ftHgl                          */

}CANRcvDataType;

typedef union{
    UINT8 byte;
    struct{
        UINT8     event:1;              /* CxgM                      */
        UINT8     peri:1;               /* M                          */
        UINT8     chgsnd:1;             /* Cxg+M(^Cv2)        */
        UINT8     dummy:5;
    }bit;
}CANSndModeType;

typedef struct{                         /* Mf[^֘A                    */
    UINT16    data_id;                  /* f[^ID                          */
    UINT16    can_id;                   /* CAN-ID                            */
    CANSndModeType      snd_mode;       /* M[h                        */
    UINT8     use_keep_intv;            /* MԊum(msec)                */
    UINT8     dlc;                      /* DLC                               */
    UINT16    offset;                   /* M̃ItZbgl(ms)        */
    UINT16    snd_cycle;                /* MTCN(ms)              */
    DataType  def;                      /* ftHgl                      */
}CANSndDataType;

/*---------------------------------------------------------------------------*/
/*  Oe[u                                                             */
/*---------------------------------------------------------------------------*/
/* ԗʒʐMdl֘A */
extern const CANIDType CANID_TABLE[CAN_COM_NUM_CANID];
extern const CANRcvDataType CANRCVDATA_TABLE[CAN_COM_NUM_RCVDATA];
extern const CANSndDataType CANSNDDATA_TABLE[CAN_COM_NUM_SNDDATA];
#ifdef CAN_COM_NM_INDIRECT
extern const UINT16 CAN_RCV_IDX_TBL[CAN_COM_NUM_RCVDATA];
#endif

/*---------------------------------------------------------------------------*/
/*  J֐                                                                 */
/*---------------------------------------------------------------------------*/
/* COM֐ */
extern void InitCOM(void);              /* COM֐                     */
extern void RcvCOM(void);               /* COMM֐                   */
extern void SndCOM(void);               /* COMM֐                   */
extern void CntCOM(void);               /* 1msJEg֐                   */

extern void InitBufferCOM(void);        /* APIMobt@֐       */

extern StatusType ResetSndCOM(void);    /* Mr⎞CANRg[   */

extern StatusType GetStsCOM(COMStsType *);
                                        /* COM󋵎擾֐               */

extern StatusType GetSndMsgStsCOM(UINT16, CANAPIDataStsType *);
                                        /* Mobt@󋵎擾֐          */
extern StatusType GetRcvMsgStsCOM(UINT16, CANAPIDataStsType *);
                                        /* Mobt@󋵎擾֐          */
extern StatusType GetRcvAllMsgStsCOM(COMRcvDataStsType **);
                                        /* SMf[^IDXe[^XJ֐  */

extern StatusType SendMessage(UINT16, UINT8, const UINT8 far *);
                                        /* ڃbZ[WM֐            */
extern void UpdateSndCntCOM(void);      /* COMMbZ[WXV֐ */

extern StatusType SetSndUseReqCOM(UINT16, UINT8);/* M/֎~v    */

/* AAL֐ */
extern StatusType GetCOMCtrlSts(COMStsType *);
extern StatusType GetNMStatus(UINT8 *);

#endif  /* __CAN_COM_EXT_H_INCLUDE__ */

/****** End of File **********************************************************/
