/*
 *	TOPPERS NonOS CAN Middleware
 *		Toyohashi Open Platform for Embedded Real-Time Systems
 *		NonOS CAN Middleware
 * 
 *	Copyright (C) 2007 Sunny Giken Inc.
 * 
 *	L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *	ɂČ\Ă GNU General Public License  Version 2 ɋL
 *	qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *	ς̂܂ށDȉjgpEEρEĔzziȉC
 *	pƌĂԁj邱Ƃ𖳏ŋD
 *	(1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *		\C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *		XR[hɊ܂܂Ă邱ƁD
 *	(2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *		pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *		҃}jAȂǁjɁCL̒쌠\C̗pщL
 *		̖ۏ؋Kfڂ邱ƁD
 *	(3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *		płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *		ƁD
 *	  (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *		  쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *	  (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *		  񍐂邱ƁD
 *	(4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *		QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *	{\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *	TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *	܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *	ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */
/*
 *@Version 1.00  2007.10.26
 */

#ifndef __CAN_NM_EXT_H_INCLUDE__
#define __CAN_NM_EXT_H_INCLUDE__

/*---------------------------------------------------------------------------*/
/* ft@C`                                                            */
/*---------------------------------------------------------------------------*/
/* COM萔 */
#define CAN_NM_STP     ((UINT8)(0x00))     /* COM~ */
#define CAN_NM_RCVONLY ((UINT8)(0x0C))     /* COMM */
#define CAN_NM_WAITING ((UINT8)(0x0D))     /* COMM֎~ */
#define CAN_NM_NML     ((UINT8)(0x0F))     /* COMS쒆 */

#define CAN_NM_BUS_SLEEP        ((UINT8)(0))    /* ECUWakeUpv             */
#define CAN_NM_AWAKE            ((UINT8)(1))    /* ECUSleepv              */

/*---------------------------------------------------------------------------*/
/*  ^`                                                                   */
/*---------------------------------------------------------------------------*/
typedef UINT8 CfgKndName;                 /* NMRtBO[Ve[uw */
typedef UINT8 CfgRefType;                 /* NMRtBO[V`         */

typedef struct{
    UINT8 sndstop:1;                      /* NMM~tO                */
    UINT8 rcvstop:1;                      /* NMM~tO                */
    UINT8 dummy:6;
}NMStsType;

/* NMMXe[^X */
typedef union{
    struct{
        UINT8 StatusRingStable:1;         /* lbg[N              */
        UINT8 StatusBusError:1;           /* oXIt                    */
        UINT8 StatusNMActive:1;           /* NMActive(͖)        */
        UINT8 StatusLimpHome:1;           /* NMLimpHome                  */
        UINT8 StatusBusSleep:1;           /* NMBusSleep                  */
        UINT8 StatusWaitBusSleep:1;       /* NMTwbsNormal,NMTwbsLimpHome */
        UINT8 StatusTxRingDataNotAllowed:1;   /* RingMsg̃f[^̈ւ
                                                            ANZX֎~     */
        UINT8 StatusBusSleepInd:1;        /* Sleep.ind                   */
    }bit;
    UINT8 byte;
}NetStsType;

/* COMʐM(NMQƗp) */
typedef union{
    struct{
        UINT8     en_sndque:1;            /* ML[                  */
        UINT8     en_snd:1;               /* M                        */
        UINT8     en_rcvque:1;            /* ML[                  */
        UINT8     en_rcv:1;               /* M                        */
        UINT8     sndstop:1;              /* Mr                    */
        UINT8     rcvstop:1;              /* Mr                    */
        UINT8     dummy:2;
    }bit;
    UINT8 byte;
}NMCOMStsType;

/*---------------------------------------------------------------------------*/
/*  J֐                                                                 */
/*---------------------------------------------------------------------------*/
/* NM֐ */
extern void InitNM(void);               /* NM֐                      */
extern void TickNM(void);               /* NM֐                        */
extern void FncBeforeSlpNM(void);       /* WakeUpO֐                  */
extern void FncAfterSlpNM(void);        /* WakeUp㏈֐                  */

extern StatusType GetWkupStsNM(void);   /* WakeUp荞݌o֐            */
extern StatusType GetStatus(NetStsType *);
                                        /* NMlbg[N擾֐        */
extern StatusType GetStsNM(NMStsType *);/* NM󋵎擾֐                */
extern StatusType GetCOMCtrlStsNM(NMCOMStsType *);
                                        /* COM擾֐               */
extern StatusType GetForm(UINT8 **, UINT8 **);
                                        /* NMOԎ擾֐              */
extern StatusType GoToMode(UINT8);      /* AppWakeUpESleepݒ֐      */
extern StatusType GetConfig(CfgKndName, CfgRefType **);/*NMǫ̇ܰڰ */
                                                       /*      擾֐  */

#endif  /* __CAN_NM_EXT_H_INCLUDE__ */

/****** End of File **********************************************************/
