/*
 *	TOPPERS NonOS CAN Middleware
 *		Toyohashi Open Platform for Embedded Real-Time Systems
 *		NonOS CAN Middleware
 * 
 *	Copyright (C) 2007 Sunny Giken Inc.
 * 
 *	L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *	ɂČ\Ă GNU General Public License  Version 2 ɋL
 *	qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *	ς̂܂ށDȉjgpEEρEĔzziȉC
 *	pƌĂԁj邱Ƃ𖳏ŋD
 *	(1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *		\C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *		XR[hɊ܂܂Ă邱ƁD
 *	(2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *		pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *		҃}jAȂǁjɁCL̒쌠\C̗pщL
 *		̖ۏ؋Kfڂ邱ƁD
 *	(3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *		płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *		ƁD
 *	  (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *		  쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *	  (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *		  񍐂邱ƁD
 *	(4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *		QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *	{\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *	TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *	܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *	ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */
/*
 *@Version 1.00  2007.10.26
 */

#ifndef __CAN_NM_H_INCLUDE__
#define __CAN_NM_H_INCLUDE__

/*---------------------------------------------------------------------------*/
/* }N`                                                                */
/*---------------------------------------------------------------------------*/
#define CAN_NM_DIV8         ((UINT8)(3))            /* 8̏Z̼        */
#define CAN_NM_RST8         ((UINT8)(7))            /* 8̏Z̗]Ͻ  */

/* Msg */
#define CAN_ALIVEMSG        ((UINT8)(0x01))         /* AliveMsg              */
#define CAN_RINGMSG         ((UINT8)(0x02))         /* RingMsg               */
#define CAN_LIMPHOMEMSG     ((UINT8)(0x04))         /* LimpHomeMsg           */

/* e */
#define CAN_NM_TTYP         ((NMTimerType)(0x08))   /* Ttyp               */
#define CAN_NM_TMAX         ((NMTimerType)(0x10))   /* Tmax               */
#define CAN_NM_TERR         ((NMTimerType)(0x20))   /* Terr               */
#define CAN_NM_TWBS         ((NMTimerType)(0x40))   /* Twbs               */
#define CAN_NM_TALL         ((NMTimerType)(0xFF))   /* NMgpS           */

/* eϽ */
#define CAN_M_OPCODE            ((UINT8)(0x07))     /* NMүގʔϽ   */
#define CAN_NM_SOURCE_ID_MASK   ((~CAN_NM_WINDOW_MASK) & (UINT16)(0x7ff))
                                                    /* Source ID Mask        */

#define CAN_ALL_MYSELF      ((UINT8)(CAN_NM_MY_CAN_ID & CAN_NM_SOURCE_ID_MASK))
                                                    /* NMp̃m[hhc      */

#define CAN_NM_DLC_MAX ((UINT8)(8))                 /* DLCTCYől       */
#define CAN_NM_DLC_MIN ((UINT8)(2))                 /* DLCTCYŏl       */

/* NMȯܰðl */
#define     CAN_NM_INVAL1   ((UINT8)(0x03))         /* StatusRingStable=ON   */
                                                    /*     StatusBusError=ON */
#define     CAN_NM_INVAL2   ((UINT8)(0x09))         /* StatusRingStable=ON   */
                                                    /*     StatusLimpHome=ON */
#define     CAN_NM_INVAL3   ((UINT8)(0x11))         /* StatusRingStable=ON   */
                                                    /*     StatusBusSleep=ON */
#define     CAN_NM_INVAL4   ((UINT8)(0x21))         /* StatusRingStable=ON   */
                                                    /* StatusWaitBusSleep=ON */
#define     CAN_NM_INVAL5   ((UINT8)(0x12))         /* StatusBusError=ON     */
                                                    /*     StatusBusSleep=ON */
#define     CAN_NM_INVAL6   ((UINT8)(0x18))         /* StatusLimpHome=ON     */
                                                    /*     StatusBusSleep=ON */
#define     CAN_NM_INVAL7   ((UINT8)(0x30))         /* StatusBusSleep=ON     */
                                                    /*  StatusWaitBusSleep=ON*/
#define     CAN_NM_INVAL8   ((UINT8)(0x90))         /* StatusBusSleep=ON     */
                                                    /*  StatusBusSleepInd=ON */
#define     CAN_NM_INVAL9   ((UINT8)(0xa0))         /* StatusWaitBusSleep=ON */
                                                    /*  StatusBusSleepInd=ON */

/* eϐl */
#define CAN_NM_INIT_NETSTS  ((UINT8)(0x40))         /* NMȯܰðl   */
#define CAN_NM_INIT_PWRON   ((UINT8)(0x00))         /* ޯ؋Nl     */
#define CAN_NM_SLP_NETSTS   ((UINT8)(0x54))         /* NMȯܰðBusSleep */
#define CAN_NM_WKUP_NETSTS  ((UINT8)(0x44))         /* NMȯܰðWakeUp   */

#define CAN_NM_OPCODE       ((UINT8)(1))            /* OpCpde:DataField[1]   */

/* (WKUP,INIT)ݒl */
#define CAN_NM_WKUP         ((UINT8)(0x80))         /* WakeUpN          */

/* OSEK-NM */                                                         /* L0-L1-L2-xx */
#define CAN_NMOff                               ((NMModeStsType)(0x00))   /* 00-xx-xx-xx */
#define CAN_NMOn                                ((NMModeStsType)(0x40))   /* 01-xx-xx-xx */
    #define CAN_NMInit                          ((NMModeStsType)(0x40))   /* 01-00-xx-xx */
    #define CAN_NMAwake                         ((NMModeStsType)(0x50))   /* 01-01-xx-xx */
        #define CAN_NMReset                     ((NMModeStsType)(0x50))   /* 01-01-00-xx */
        #define CAN_NMNormal                    ((NMModeStsType)(0x54))   /* 01-01-01-xx */
            #define CAN_NMNormalPrepBusSleep    ((NMModeStsType)(0x55))   /* 01-01-01-01 */
            #define CAN_NMTwbsNormal            ((NMModeStsType)(0x56))   /* 01-01-01-10 */
        #define CAN_NMLimpHome                  ((NMModeStsType)(0x58))   /* 01-01-10-xx */
            #define CAN_NMLimpHomePrepBusSleep  ((NMModeStsType)(0x59))   /* 01-01-10-01 */
            #define CAN_NMTwbsLimpHome          ((NMModeStsType)(0x5a))   /* 01-01-10-10 */
        #define CAN_NMTwbs/* Normal,LimpHome */ ((NMModeStsType)(0x5e))   /* 01-01-11-10 */
    #define CAN_NMBusSleep                      ((NMModeStsType)(0x60))   /* 01-10-xx-xx */
#define CAN_NMShutDown                          ((NMModeStsType)(0x80))   /* 10-xx-xx-xx */

#define CAN_NM_DLC_SIZE     ((UINT8)(8))            /* CANbZ[WDLC    */

#define CAN_Normal      ((CfgKndName)(0))
#define CAN_LimpHome    ((CfgKndName)(1))



/*---------------------------------------------------------------------------*/
/* ^`                                                                    */
/*---------------------------------------------------------------------------*/
typedef UINT8 NMModeStsType;                    /* NM                    */
typedef UINT8 NMTimerType;                      /* NM                     */

/* NM֌W */
typedef union{
    struct{
        UINT8   wkup_seq:1;                     /* WakeUpNݽ׸       */
        UINT8   wkup_fct:1;                     /* ȯܰWakeUpo׸    */
        UINT8   en_snddata:1;                   /* MްL׸          */
        UINT8   rcv_comp:1;                     /* M׸              */
        UINT8   cnt_ring:1;                     /* RingMsg׸           */
        UINT8   dis_ring:1;                     /* MRingMsg׸       */
        UINT8   dummy:2;
    }bit;
    UINT8 byte;
}NMCtlStsType;

/* ϐ */
typedef union{
    struct{
        UINT8   ttyp:1;                         /* TtypĊJn׸          */
        UINT8   tmax:1;                         /* TmaxĊJn׸          */
        UINT8   terr:1;                         /* TerrĊJn׸          */
        UINT8   twbs:1;                         /* TwbsĊJn׸          */
        UINT8   dummy1:4;                       /* dummy                     */
    }bit;
    UINT8 byte;
}NMCntTimerType;

typedef union{
    struct{
        UINT8   ttyp:1;                         /* Ttypѱ׸            */
        UINT8   tmax:1;                         /* Tmaxѱ׸            */
        UINT8   terr:1;                         /* Terrѱ׸            */
        UINT8   twbs:1;                         /* Twbsѱ׸            */
        UINT8   dummy:4;
    }bit;
    UINT8 byte;
}NMTimeOutType;

/* NM M Format */
typedef struct{
    UINT8   rd_ptr;                             /* ǂݍݍς߲         */
    UINT8   wr_ptr;                             /* ߲             */
    CANMsgType  msg[CAN_NM_NUM_SNDQUE];         /* CANMү             */
}NMSndQueType;

/* NMML[ */
typedef struct{
    UINT8 rd_ptr;                        /* ǂݍ݃|C^                 */
    UINT8 wr_ptr;                        /* ݃|C^                 */
    CANMsgType  msg[CAN_NM_NUM_RCVQUE];  /* CANMbZ[W                */
}NMRcvQueType;

/* NM Message :Control Field(OpCode) */
typedef union{
    struct{
        UINT8 alive:1;                          /* AliveMsgMޯ          */
        UINT8 ring:1;                           /* RingMsgMޯ           */
        UINT8 limphome:1;                       /* LimpHomeMsgMޯ       */
        UINT8 dummy1:1;                         /* dummy                     */
        UINT8 sleepind:1;                       /* Sleep.ind                 */
        UINT8 sleepack:1;                       /* Sleep.ack                 */
        UINT8 dummy2:2;                         /* dummy                     */
    }bit;
    UINT8 byte;
}OpCodeType;

typedef struct{
    UINT16          canid;                      /* CAN ID                    */
    UINT8           destid;                     /* Dest ID                   */
    OpCodeType      opcode;                     /* OpCode                    */
}NMMsgType;

/* ECU */
typedef struct{
    UINT8     req_slp:1;                  /* [TRUE]oXX[v      */
    UINT8     dummy:7;
}ECUStsType;

#endif  /* #ifndef __CAN_NM_DEF_H_INCLUDE__    */